# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%bcond_without mead
%define _jarsign_opts --copy=%{_javadir} --unsign=%{_javadir}

%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif

%global repodir %{_javadir}/repository.jboss.com/org/jboss/spec/%{apigroupids}/%{apiartifactid}/%{namedversion}-brew
%global repodirlib %{repodir}/lib
%global repodirsrc %{repodir}/src

%global alternativespriority 010100
%global apiname jms
%global apiversion 1.1
%global apiversionu 1_1
%global ver 1.0.1
%global rel 1%{?reltag}
%global reltag .Final_redhat_1
%global namedreltag .Final-redhat-1
%global namedversion %{version}%{?namedreltag}
%global apigroupid javax.jms
%global apigroupids javax/jms
%global apiartifactid %{apiname}-api

%define section free

%define maven_version 1.0.1.Final-redhat-1

Name:           jboss-%{apiname}-api_%{apiversion}_spec
Version:        %{ver}
Release:        %{rel}%{?dist}
Epoch:          0
Summary:        JBoss %{apiname} %{apiversion} API
License:        LGPLv2+
URL:            http://fisheye.jboss.org/browse/JBossAS/projects/specs/tags/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}
Group:          Development/Libraries/Java

%if %with mead
Source100: org.jboss.spec.javax.jms-jboss-jms-api_1.1_spec-1.0.1.Final-redhat-1-sources.zip
Source101: org.jboss.spec.javax.jms-jboss-jms-api_1.1_spec-1.0.1.Final-redhat-1-patches.zip
Source102: jboss-jms-api_1.1_spec-1.0.1.Final-redhat-1-javadoc.jar
Source103: jboss-jms-api_1.1_spec-1.0.1.Final-redhat-1-sources.jar
Source104: jboss-jms-api_1.1_spec-1.0.1.Final-redhat-1.jar
Source105: jboss-jms-api_1.1_spec-1.0.1.Final-redhat-1.pom
%endif

# svn export http://anonsvn.jboss.org/repos/jbossas/projects/specs/tags/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion} && tar cjf jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}.tar.bz2 jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}
# FIXME: normal RPM builds (without mead) will fail without a Source0
#Source0:        jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}.tar.bz2
#Source3:        jms-api-1.1.pom
#Patch0:         jboss-%{apiname}-api_%{apiversion}_spec-pom.patch
Provides:       %{apiname}_%{apiversionu}_api
Provides:       %{apiname}_api = 0:%{apiversion}
Requires(preun): %{_sbindir}/update-alternatives
Requires(post): %{_sbindir}/update-alternatives
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
Requires:       jboss-specs-parent >= 1.0.0-0.1.Beta2
%if %with mead
BuildRequires:  unzip
%else
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-project-info-reports-plugin
BuildRequires:  maven-skins
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-surefire-report-plugin
BuildRequires:  mojo-maven2-plugin-taglist
BuildRequires:  jboss-parent
BuildRequires:  jboss-specs-parent >= 1.0.0-0.1.Beta2
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss %{apiname} %{apiversion} API.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

Requires(preun): %{_sbindir}/update-alternatives
Requires(post): %{_sbindir}/update-alternatives
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %without mead
%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation

Requires(preun): %{_sbindir}/update-alternatives
Requires(post): %{_sbindir}/update-alternatives
Requires:       %{name}-javadoc = %{epoch}:%{version}-%{release}

%description manual
%{summary}.
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q -n jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
%{_bindir}/mvn-jpp -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} javadoc:aggregate javadoc:jar source:jar deploy site
%endif

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}/
%if %without mead
pushd maven2-brew
%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}.jar %{buildroot}%{_javadir}/
%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/
%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-sources.jar %{buildroot}%{_javadir}/
%else
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}-javadoc.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-javadoc.jar
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-sources.jar
%endif
(cd %{buildroot}%{_javadir}/ && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# jar alternatives
/bin/touch %{buildroot}%{_javadir}/%{apiname}_api.jar
/bin/touch %{buildroot}%{_javadir}/%{apiname}_%{apiversionu}_api.jar

# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%if %without mead
%{__cp} -p org/jboss/spec/javax/xml/rpc/jboss-%{apiname}-api_%{apiversion}_spec/%{namedversion}/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jboss-%{apiname}-api_%{apiversion}_spec.pom
%else
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jboss-%{apiname}-api_%{apiversion}_spec.pom
%endif

# pom alternatives
/bin/touch %{buildroot}%{_datadir}/maven2/poms/JPP-%{apiname}_%{apiversionu}_api.pom
/bin/touch %{buildroot}%{_datadir}/maven2/poms/JPP-%{apiname}_api.pom

%if %without mead
popd
%endif

# depmaps
%add_to_maven_depmap org.jboss.spec.%{apigroupid} jboss-%{apiname}-api_%{apiversion}_spec %{namedversion} JPP jboss-%{apiname}-api_%{apiversion}_spec
%add_to_maven_depmap %{apigroupid} %{apiartifactid} %{apiversion} JPP %{apiname}_%{apiversionu}_api

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%if %without mead
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%else
%{__unzip} -qq %{_sourcedir}/%{name}-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__rm} -r %{buildroot}%{_javadocdir}/%{name}-%{namedversion}/META-INF
%endif
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

# javadoc alternatives
/bin/touch %{buildroot}%{_javadocdir}/%{apiname}_%{apiversionu}_api
/bin/touch %{buildroot}%{_javadocdir}/%{apiname}_api

%if %without mead
# manual
%{__mkdir_p} %{buildroot}%{_docdir}/%{name}-%{namedversion}
%{__cp} -pr target/site/* %{buildroot}%{_docdir}/%{name}-%{namedversion}
%{__rm} -r %{buildroot}%{_docdir}/%{name}-%{namedversion}/apidocs
%{__ln_s} %{_docdir}/%{name}-%{namedversion} %{buildroot}%{_docdir}/%{name}
%{__ln_s} %{_javadocdir}/%{name} %{buildroot}%{_docdir}/%{name}-%{namedversion}/apidocs

# manual alternatives
/bin/touch %{buildroot}%{_docdir}/%{apiname}_%{apiversionu}_api
/bin/touch %{buildroot}%{_docdir}/%{apiname}_api
%endif

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
%{__install} -d -m 755 %{buildroot}%{repodirlib}
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar %{buildroot}%{repodirlib}/
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{namedversion}-sources.jar %{buildroot}%{repodirlib}/
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-jboss-%{apiname}-api_%{apiversion}_spec.pom %{buildroot}%{repodirlib}/
%{__install} -d -m 755 %{buildroot}%{repodirsrc}
%if %without mead
%{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
%{__cp} -p %{SOURCE0} %{buildroot}%{repodirsrc}
%else
%{__cp} -p %{_sourcedir}/org.jboss.spec.%{apigroupid}-jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-*.zip %{buildroot}%{repodirsrc}
%endif
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%{_sbindir}/update-alternatives --install %{_javadir}/%{apiname}_api.jar %{apiname}_api %{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec.jar %{alternativespriority}
%{_sbindir}/update-alternatives --install %{_javadir}/%{apiname}_%{apiversionu}_api.jar %{apiname}_%{apiversionu}_api %{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec.jar %{alternativespriority}
%{_sbindir}/update-alternatives --install %{_datadir}/maven2/poms/JPP-%{apiname}_api.pom %{apiname}_api_pom %{_datadir}/maven2/poms/JPP.%{name}-jboss-%{apiname}-api_%{apiversion}_spec.pom %{alternativespriority}
%{_sbindir}/update-alternatives --install %{_datadir}/maven2/poms/JPP-%{apiname}_%{apiversionu}_api.pom %{apiname}_%{apiversionu}_api_pom %{_datadir}/maven2/poms/JPP.%{name}-jboss-%{apiname}-api_%{apiversion}_spec.pom %{alternativespriority}
%update_maven_depmap

%preun
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove %{apiname}_api %{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec.jar
    %{_sbindir}/update-alternatives --remove %{apiname}_%{apiversionu}_api %{_javadir}/jboss-%{apiname}-api_%{apiversion}_spec.jar
    %{_sbindir}/update-alternatives --remove %{apiname}_api_pom %{_datadir}/maven2/poms/JPP.%{name}-jboss-%{apiname}-api_%{apiversion}_spec.pom
    %{_sbindir}/update-alternatives --remove %{apiname}_%{apiversionu}_api_pom %{_datadir}/maven2/poms/JPP.%{name}-jboss-%{apiname}-api_%{apiversion}_spec.pom
fi

%postun
%update_maven_depmap

%post javadoc
%{_sbindir}/update-alternatives --install %{_javadocdir}/%{apiname}_api %{apiname}_api_javadoc %{_javadocdir}/%{name} %{alternativespriority}
%{_sbindir}/update-alternatives --install %{_javadocdir}/%{apiname}_%{apiversionu}_api %{apiname}_%{apiversionu}_api_javadoc %{_javadocdir}/%{name} %{alternativespriority}

%preun javadoc
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove %{apiname}_api_javadoc %{_javadocdir}/%{name}
    %{_sbindir}/update-alternatives --remove %{apiname}_%{apiversionu}_api_javadoc %{_javadocdir}/%{name}
fi

%if %without mead
%post manual
%{_sbindir}/update-alternatives --install %{_docdir}/%{apiname}_api %{apiname}_api_manual %{_docdir}/%{name} %{alternativespriority}
%{_sbindir}/update-alternatives --install %{_docdir}/%{apiname}_%{apiversionu}_api %{apiname}_%{apiversionu}_api_manual %{_docdir}/%{name} %{alternativespriority}

%preun manual
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove %{apiname}_api_manual %{_docdir}/%{name}
    %{_sbindir}/update-alternatives --remove %{apiname}_%{apiversionu}_api_manual %{_docdir}/%{name}
fi
%endif

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}*/
%exclude %dir %{_javadocdir}
%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}.jar
%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec.jar
%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-javadoc.jar
%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec-javadoc.jar
%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec-%{namedversion}-sources.jar
%{_javadir}*/jboss-%{apiname}-api_%{apiversion}_spec-sources.jar
%ghost %{_javadir}*/%{apiname}_%{apiversionu}_api.jar
%ghost %{_javadir}*/%{apiname}_api.jar
%{_datadir}/maven2/poms/JPP.%{name}-jboss-%{apiname}-api_%{apiversion}_spec.pom
%ghost %{_datadir}/maven2/poms/JPP-%{apiname}_%{apiversionu}_api.pom
%ghost %{_datadir}/maven2/poms/JPP-%{apiname}_api.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}
%ghost %{_javadocdir}/%{apiname}_api
%ghost %{_javadocdir}/%{apiname}_%{apiversionu}_api

%if %without mead
%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{namedversion}
%doc %{_docdir}/%{name}
%doc %ghost %{_docdir}/%{apiname}_%{apiversionu}_api
%doc %ghost %{_docdir}/%{apiname}_api
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed May 02 2012 Vladimir Dosoudil <dosoudil@redhat.com> - 0:1.0.1-1.Final_redhat_1
- Upgrade to 1.0.1.Final

* Mon Mar 19 2012 Martha Benitez <mbenitez@redhat.com> - 0:1.1-2.Final_redhat_1.3
- Remove define _jarsign_opts

* Mon Mar 19 2012 Martha Benitez <mbenitez@redhat.com> - 0:1.1-2.Final_redhat_1.2
- Upgrade to new wrapper
- Fix jars' installation path

* Wed Jan 18 2012 David Walluck <dwalluck@redhat.com> 0:1.1-1
- first Brew build

* Wed Jan 18 2012 David Walluck <dwalluck@redhat.com> 0:1.1-1
- release
